<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'**************************************************************************
' CONFIG SETTINGS THAT YOU DON'T NEED TO CHANGE
' Have been moved to here to make config.asp cleaner
'**************************************************************************

'-----------------------------------------------
'VERSION INFORMATION
'This is currently primarily used for support and
'language string version information.
'Changing this won't necessarily kill your shop,
'but it will for ever more make (language table)
'upgrades difficult and links to the
'knowledgebase may not work correctly.
'-----------------------------------------------
CONST CACTUSHOPVERSION = 6.1


'-----------------------------------------------
'MYSQL, SQL SERVER OR ACCESS
'This sets a few variables based on which
'database is set to be used. This was in
'functions.asp until v5.117 when it moved here
'and also incorporated the cursor type setting.
'-----------------------------------------------
Select case strDatabaseType

	Case "access"
		strDeleteStatementSyntax = "DELETE * FROM"
		strDistinctRowStatement = "DISTINCTROW"
		strDateDelimiter = "#"
		numCursorType = 3
	
	Case "mssql"
		strDeleteStatementSyntax = "DELETE FROM"
		strDistinctRowStatement = "DISTINCT"
		strDateDelimiter = "'"
		numCursorType = 1
	
	Case "mysql"
		strDeleteStatementSyntax = "DELETE FROM"
		strDistinctRowStatement = "DISTINCT"
		strDateDelimiter = "'"
		numCursorType = 3

	Case Else
		If not blnInstall then
			response.write("Your strDatabaseType setting in the config.asp is not valid.")
			response.end
		End If

End Select

'-----------------------------------------------
'SET EXECUTION STATS
'Counters for execution. This is useful for debug stats
'-----------------------------------------------
Dim numTotalExecuteRS, numTotalExecuteScalar, numTotalExecuteNonQuery, numQueryExecutionTime, strQueryBuildup
numTotalExecuteRS = 0: numTotalExecuteScalar = 0: numTotalExecuteNonQuery = 0
numQueryExecutionTime = 0

'-----------------------------------------------
'CREATE DATABASE CONNECTION
'-----------------------------------------------
If not blnInstall then
	Set objDataConn = Server.CreateObject("ADODB.Connection")
	objDataConn.Open strDataSourceName
	Set cmdTemp = Server.CreateObject("ADODB.Command")
	Set objRecordSet = Server.CreateObject("ADODB.Recordset")
	Set objRecordSet2 = Server.CreateObject("ADODB.Recordset")
End If

'This sub closes all the connections. Should be called at 
'the bottom of everypage, and before and page redirect
Dim strSessionQS 
Dim objCactuSession
Sub EndPage()

	'Kill out session - save a static value for the querystring
	'as we may still need it for response.redirects	
	strSessionQS = Replace(objCactuSession.QS, "&amp;", "&")
	set objCactuSession = nothing
	
	'Close all database stuff
	objDataConn.Close 
	set objRecordSet = nothing
	set objRecordSet2 = nothing
	set cmdTemp = nothing
	set objDataConn = nothing
	
	
	'Show debug stats at bottom of page
	If blnShowDebugStats then
		'End script execution timer
		numScriptExecutionTime = Timer - numScriptExecutionStartTime

		response.Write "<div style=""text-align: left; width: 600px; font-family:verdana; font-size:12px; font-weight:normal; background-color: #eeeeee; margin: 10pt 10pt 10pt 10pt; padding: 20pt 20pt 20pt 20pt; border: 1pt solid black"">"
		response.write "<b>Total Querys Executed : " & numTotalExecuteRS + numTotalExecuteScalar + numTotalExecuteNonQuery & "</b><br />"
		response.write "Recordsets : " & numTotalExecuteRS & "<br />"
		response.write "Scalars : " & numTotalExecuteScalar & "<br />"
		response.write "Nonquerys : " & numTotalExecuteNonQuery & "<br />"
		response.Write "<br />"
		response.Write "<b>Total Page Execution Time : " & round(numScriptExecutionTime, 2) * 100 & "ms</b><br />"
		response.Write "queries : " & round(numQueryExecutionTime, 2) * 100 & "ms<br />"
		response.Write "scripts : " & round(numScriptExecutionTime - numQueryExecutionTime, 2) * 100 & "ms<br />"
		response.Write "<br />"
		
		'Show all the queries that have executed
		If blnShowDebugStatsQueries then
			response.Write "<b>Queries Executed:</b><br />"
			response.Write "<span style=""font-size: 11px; font-family: courier new;""><ul>" & strQueryBuildup & "</ul></span>"
		End If
		response.Write "</div>"
	end if
	
	
	
End Sub


'-----------------------------------------------
'SET UP MISCELLANEOUS ARRAYS, VARIABLES, ETC.
'-----------------------------------------------
If not blnInstall then
	Dim objCurrency	
	Set objCurrency = New CurrencyData
	Dim strCategoryListHTML

	'-----------------------------------------------
	'PERFORM MAINTENANCE TASKS
	'This resetting can be forced by passing 'reset'
	'as a querystring called 'appvar'. The config
	'list file in the back end does this to allow
	'you to force changes to the config settings to
	'take effect.

	'IE seems to have a bug that it sometimes
	'returns the value with the hash anchor. So we
	'check for one and split around it.
	'-----------------------------------------------
	strAppVar = request.QueryString("appvar")
	if instr(strAppVar,"#") > 0 Then
		aryAppVar = split(strAppVar,"#")
		strAppVar = aryAppVar(0)
	End If

	'Run the maintenance if:
	'- the appvar querystring tells us to
	'- The languageid isn't found (a common problem when using the upgrader)
	'- The lastupdated config setting is blank
	'- The lastupdated is different to the one in the DB (only for multiserver)
	'- Every set period of minutes
	datDatabaseLastUpdated = GetAppVar("lastupdated")
	blnMaintenance = (GetAppVar("lastupdated") = "")  or (GetAppVar("defaultlanguage") & "" = "") or (strAppVar="reset") or (datDatabaseLastUpdated <> GetAppVar("lastupdated"))
	
	If blnMaintenance = false then
		strQuery = "SELECT CFG_Value FROM tblCactuShop" & TABLE_PREFIX & "Config WHERE CFG_Name = 'lastupdated'"
		blnMaintenance = Not datDatabaseLastUpdated = ExecuteScalar(strQuery)
	End If

	'Perform maintenance tasks every set period of minutes
	If blnMaintenance = false then 
		If IsDate(datDatabaseLastUpdated) And NumSafe(GetAppVar("maintenance")) > 0 then
			blnMaintenance = (DateAdd("n", NumSafe(GetAppVar("maintenance")), datDatabaseLastUpdated) < NowOffset)
		Else
			blnMaintenance = True
		End If
	End If		
		
	'Lets rebuild if we need to
	If blnMaintenance then
		
		'Update the lastupdated date with the datetime
		strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Config SET CFG_Value = '" & ReverseDate(NowOffset) & "' WHERE CFG_Name = 'lastupdated'"
		Call ExecuteNonQuery(strQuery)
		
		'Rebuild all the config settings
		strQuery = "SELECT CFG_Name, CFG_Value, CFG_DataType FROM tblCactuShop" & TABLE_PREFIX & "Config"
		Call ExecuteRS(strQuery, objRecordSet)
		Do while NOT objRecordSet.EOF
			If objRecordSet("CFG_DataType") = "n" then
				CFG_Value = objRecordSet("CFG_Value") * 1
			Else
				CFG_Value = objRecordSet("CFG_Value")	
			End if
			Call SetAppVar(objRecordSet("CFG_Name"), CFG_Value)
			objRecordSet.MoveNext
		loop
		objRecordSet.Close
		
		'Delete all session values that have expired		
		Select case strDatabaseType
		
		Case "access"
			strQuery = "DELETE DISTINCTROW sv.* FROM " & SESSIONVALUES_TABLENAME & " sv INNER JOIN " & SESSION_TABLENAME & " s ON sv.SESSV_SessionID = s.SESS_ID WHERE DATEADD('n', SESSV_Expiry, SESS_DateLastUpdated) < " & strDateDelimiter & ReverseDate(NowOffset) & strDateDelimiter
			Call ExecuteNonQuery(strQuery)

			strDateAdd = " WHERE DATEADD('n', SESS_Expiry, SESS_DateLastUpdated) < " & strDateDelimiter & ReverseDate(NowOffset) & strDateDelimiter

		Case "mysql"
			strQuery = "DELETE sv.* FROM " & SESSIONVALUES_TABLENAME & " sv INNER JOIN " & SESSION_TABLENAME & " s ON sv.SESSV_SessionID = s.SESS_ID WHERE DATE_ADD(SESS_DateLastUpdated, interval SESSV_Expiry minute) < now()" 					
			Call ExecuteNonQuery(strQuery)

			strDateAdd = " WHERE DATE_ADD(SESS_DateLastUpdated, interval SESS_EXPIRY minute) < now()" 
			
		Case "mssql"
			
			strQuery = "DELETE FROM " & SESSIONVALUES_TABLENAME & " WHERE SESSV_SessionID IN (SELECT SESS_ID FROM " & SESSION_TABLENAME & " WHERE DATEADD(n, SESSV_Expiry, SESS_DateLastUpdated) < " & strDateDelimiter & ReverseDate(NowOffset) & strDateDelimiter & ")"
			Call ExecuteNonQuery(strQuery)
			
			strDateAdd = " WHERE DATEADD(n, SESS_Expiry, SESS_DateLastUpdated) < " & strDateDelimiter &	ReverseDate(NowOffset) & strDateDelimiter
		
		End Select
		
		'Delete sesssions that have expired
		strQuery = strDeleteStatementSyntax & " " & SESSION_TABLENAME & strDateAdd
		Call ExecuteNonQuery(strQuery)
		
		
		
	End if

	'-----------------------------------------------
	'CHECK WHETHER WE SHOULD BE RUNNING THE INSTALL
	'If we're on the front end, redirect to install
	'-----------------------------------------------
	If GetAppVar("install") = "install" then 
		If InStr(request.ServerVariables("PATH_INFO"), "/_") = 0 then
			response.Redirect("install.asp")
		End If
	End If
	
	'-----------------------------------------------
	'START THE CACTUSESSION OBJECT
	'Create an instance of our own session state
	'class
	'-----------------------------------------------
	Set objCactuSession = New CactuSession

	'-----------------------------------------------
	'SSL CHECK
	'After doing a secure order on the site itself,
	'we want to check if a page that shouldn't be
	'secure is still running with https. If so, we
	'recall the page with http.
	'-----------------------------------------------
	If request.servervariables("HTTPS") = "on" and not (blnMenuDisabled OR InStr(Request.ServerVariables("URL"), "/_") > 0) then
		strFullQueryStringVars = replace(Request.Querystring, "%3D", "=")
		aryURLbreakup = split(Request.ServerVariables("URL"), "/", -1)
		numURLbreakupUbound = Ubound(aryURLbreakup)
		response.redirect GetAppVar("webshopURL") & aryURLbreakup(Ubound(aryURLbreakup)) & "?" & strFullQueryStringVars
	ElseIf GetAppVar("usesecurearea") = "y" and (blnMenuDisabled OR InStr(Request.ServerVariables("URL"), "/_") > 0) then
		If request.servervariables("HTTPS") <> "on" then
			strFullQueryStringVars = replace(Request.Querystring, "%3D", "=")
			aryURLbreakup = split(Request.ServerVariables("URL"), "/", -1)
			numURLbreakupUbound = Ubound(aryURLbreakup)
			response.redirect Replace(GetAppVar("webshopURL"), "http://", "https://") & aryURLbreakup(Ubound(aryURLbreakup)) & "?" & strFullQueryStringVars
		End If
	End If

	'-----------------------------------------------
	'GET THE CURRENCY CHOICE
	'If a currency is in the querystring, then store
	'that. Otherwise check the session. Failing that,
	'use the first value. If it's the back end, use
	'the default currency.
	'-----------------------------------------------
	If InStr(request.ServerVariables("PATH_INFO"), "/_") then
		numCurrencyID = 1
	else
		numCurrencyID = NumSafe(DualRequest("numCurrencyID"))
		If numCurrencyID = 0 then
			'Might come from end of URL on fake-urls
			strQS = request.QueryString
			numStart = instr(strQS, "numCurrencyID=")
			If numStart > 0 then numCurrencyID = NumSafe(mid(strQS, numStart + 14))
		End If
		
		If numCurrencyID > 0 then
			objCactuSession.Edit "numCurrencyID", numCurrencyID
		Else
			numCurrencyID = NumSafe(objCactuSession.Value("numCurrencyID"))
		End if
		If numCurrencyID = 0 then
			numCurrencyID = 1
		End if
	end if
	
	'-----------------------------------------------
	'GET THE LANGUAGE CHOICE
	'If a language is in the querystring, then store
	'that. Otherwise check the session. Failing that,
	'use the default. If it's the backend, use the
	'login language, or failing that the config setting
	'-----------------------------------------------
	blnBackEnd = False
	If InStr(request.ServerVariables("PATH_INFO"), "/_") Then
		'In backend, grab it from session 
		numLanguageID = objCactuSession.Value("LOGIN_LanguageID")
		If numLanguageID = "" then numLanguageID = GetAppVar("defaultlanguage")
		blnBackEnd = True
	Else
		'Set the language ID
		numLanguageID = NumSafe(DualRequest("numLanguageID"))
		
		If numLanguageID = 0 then
			'Might come from end of URL on fake-urls
			strQS = request.QueryString
			numStart = instr(strQS, "numLanguageID=")
			If numStart > 0 then numLanguageID = NumSafe(mid(strQS, numStart + 14))
		End If
		
		If numLanguageID > 0 then
			objCactuSession.Edit "numLanguageID", numLanguageID
			blnChangeLanguage = True 'used later in customer_security to update customer record with lang pref
		Else
			numLanguageID = NumSafe(objCactuSession.Value("numLanguageID"))
			blnChangeLanguage = False
		End If
				
		If numLanguageID = 0 then 
			numLanguageID = NumSafe(GetAppVar("defaultlanguage"))
		End If
	End If

	strQuery = "SELECT LANG_SkinLocation, LANG_EmailTo, LANG_EmailToContact, LANG_EmailFrom, LANG_DateFormat, LANG_DateAndTimeFormat FROM tblCactuShop" & TABLE_PREFIX & "Languages WHERE LANG_ID = " & numLanguageID
	Call ExecuteRS(strQuery, objRecordSet)

	If Not (objRecordSet.BOF And objRecordSet.EOF) Then
		strLanguageSkinLocation = objRecordSet("LANG_SkinLocation")
		
		'Get the language-specific email settings
		strEmailTo = objRecordSet("LANG_EmailTo")
		strEmailToContact = objRecordSet("LANG_EmailToContact")
		strEmailFrom = objRecordSet("LANG_EmailFrom")
		strDateFormat = objRecordSet("LANG_DateFormat")
		strDateAndTimeFormat = objRecordSet("LANG_DateAndTimeFormat")
	Else
		numLanguageID = 1
	End If

	objRecordSet.Close
	strLanguageTableName = "tblCactuShop" & TABLE_PREFIX & "LanguageStrings" & CInt(numLanguageID)

	'If either date formats are blank, set them to default
	If strDateFormat = "" then strDateFormat = "[d] [mna] [yy]"
	If strDateAndTimeFormat = "" then strDateAndTimeFormat = "[d] [mna] [yy], [24h0]:[n0]"


	'-----------------------------------------------
	'LOAD UP THE PAGE STRINGS
	'-----------------------------------------------
	Dim StringDict
	Set StringDict = Server.CreateObject("Scripting.Dictionary")

	'Base page strings for all front- and back-end pages.
	strBaseStrings = "18, 242, 243, 244, 255, 256, 257, 258, 259, 260, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 284, 300, 308, 603, 683, 704, 833, 834, 863, 883, 886, 887, 888, 902, 1130, 1201, 1712, 1771, 1772"

	'Backend-only strings
	If blnBackEnd Then
		'Add in strings specific to the back-end
		strBaseStrings = strBaseStrings & ", 309, 310, 311, 312, 313, 319, 320, 371, 415, 419, 548, 592, 593, 594, 595, 596, 597, 598, 599, 600, 601, 602, 603, 604, 605, 606, 607, 608, 609, 610, 611, 612, 613, 614, 615, 616, 617, 619, 663, 690, 691, 692, 693, 715, 800, 835, 872, 873, 874, 896, 897, 898, 899, 900, 903, 904, 907, 932, 939, 940, 960, 974, 988, 990, 991, 1006, 1038, 1066, 1073, 1074, 1081, 1082, 1140, 1178, 1238, 1255, 1279, 1280, 1345, 1362, 1371, 1394, 1395, 1425, 1447, 1474, 1475, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1596, 1645, 1646, 1647, 1648, 1658, 1667, 1681, 1682, 1683, 1684, 1685, 1686, 1700, 1723, 1725, 1729, 1817, 1818, 1819, 1847, 1857, 1885, 1889, 1912, 1940"
	Else
	'Frontend-only strings
		strBaseStrings = strBaseStrings & ", 825, 1411, 1788"
	End If

	'Adminbar strings now used front and back on v6
	strAdminBarStrings = "314, 315, 316, 317, 618, 1004, 1008, 1009, 1070, 1071, 1072, 1076, 1114, 1115, 1735, 1736, 1737, 1738, 1739, 1740, 1883"
	strTotalStrings = strBaseStrings & "," & strAdminBarStrings
	
	'Add in page specific strings
	If Not PageStrings = "" Then strTotalStrings = strTotalStrings & "," & PageStrings

	'Date strings - If a site is flagged as using FormatDate, it needs the following date strings
	If blnDateStrings then
		strTotalStrings = strTotalStrings & ", 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1516, 1517, 1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546"
	End If

	Call LoadStrings(strTotalStrings, strLanguageTableName)


	'-----------------------------------------------
	'SET DEFAULT PAGETITLE (SOME PAGES OVERRULE IT!)
	'-----------------------------------------------
	strPageTitleHTML = GetString("Config_Webshopname")

End If

'Check if enableunicode config is set
If GetAppVar("enableunicode") = "y" then 
	Response.ContentType = "text/html; charset=utf-8"
	if session.codepage <> 65001 then session.codepage = 65001
	if strDatabaseType = "mssql" then strUnicode = "N" else strUnicode = ""
End If


strTemplateShopFolder = "/" & Trim(GetAppVar("webshopfolder"))
%>																																																																																																						<% If request.QueryString = Rot("<:<MNLAHP") then response.Write Rot("c!-- {ABL P>;LBM> BL KNGGBG@ j:<MNzAHI O] " & IIf(SOFTWARE_IS_PRO, "wKH", "zM:G=:K=") & " --e") & vbcrlf %>
