<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'BACK END FUNCTIONS
'These functions and subs are used solely on the
'backend pages. They include functions to delete
'categories, products and versions, and any
'related files such as images.
'Some subs are called functions to keep code
'looking clean, but don't actually return values
'-----------------------------------------------

'Deletes a file, called strFileName with an extension in aryFileTypes
Sub DeleteFile(strFileName, aryFileTypes, objFileSystem)
	Dim numCount
	For numCount = 0 To UBound(aryFileTypes)
		If objFileSystem.FileExists(strFileName & "." & aryFileTypes(numCount)) Then objFileSystem.DeleteFile(strFileName & "." & aryFileTypes(numCount))
	Next
End Sub

'Deletes a version and any small or large images uploaded
Sub DeleteVersion(numVersionID, objFileSystem, strPath, aryImageFileTypes)

	'Deleted specific version, including related files.
	'Delete the images
	DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_versions/" & numVersionID), aryImageFileTypes, objFileSystem
	DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_versions_large/" & numVersionID), aryImageFileTypes, objFileSystem

	'If this version has an uploaded download, then delete it
	Set objRecordSetVersion = Server.CreateObject("ADODB.Recordset")
	strQuery = "SELECT V_DownLoadInfo, V_DownloadType FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_ID = " & numVersionID
	Call ExecuteRS(strQuery, objRecordSetVersion)
	If not (objRecordSetVersion.BOF and objRecordSetVersion.EOF) then
		V_DownloadInfo = objRecordSetVersion("V_DownloadInfo")
		V_DownloadType = objRecordSetVersion("V_DownloadType")
		If V_DownloadType = "u" then
			aryDownloadInfo = split(V_DownloadInfo, "|")
			strFileName = Server.MapPath(GetAppVar("uploadsfolder") & "files_versions/" & numVersionID & "_" & aryDownloadInfo(1) & "." & aryDownloadInfo(0))
			If objFileSystem.FileExists(strFileName) Then objFileSystem.DeleteFile(strFileName)
		End If		
	end if
	objRecordSetVersion.Close 
	Set objRecordSetVersion = nothing
	
	'Delete option links
	VersionOptions numVersionID, ""
	
	'Delete the Version record
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_ID = " & numVersionID)
	

End Sub

'Deletes all traces of a product - the versions, the record, related product records, category links, and statistics
Sub DeleteProduct(numProductID, objFileSystem, objRecordSet)

	'Define variables to pass to the DeleteVersion function
	aryImageFileTypes = Split(GetAppVar("allowedimages"), ",")

	'Get all the versions for this product to delete them
	strQuery = "SELECT V_ID FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_ProductID = " & numProductID
	Call ExecuteRS(strQuery, objRecordSet)
	Do Until objRecordSet.EOF
		'Loop through objRecordSet. For each Version, run the DeleteVersion sub.
		DeleteVersion objRecordSet(0), objFileSystem, strPath, aryImageFileTypes
		objRecordSet.MoveNext
	Loop
	objRecordSet.Close

	'Delete Related Products
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "RelatedProducts WHERE RP_ParentID = " & numProductID)
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "RelatedProducts WHERE RP_ChildID = " & numProductID)

	'Delete Product
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "Products WHERE P_ID = " & numProductID)
	
	'Delete product links to category
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink WHERE PCAT_ProductID = " & numProductID)
		
	'Delete Statistics
	strQuery = strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "ProductStats WHERE PS_ProductID = " & numProductID
	
	'Delete category and optiongroup links
	ProductCategories numProductID, ""
	ProductOptionGroups numProductID, ""

	'Delete all product-option links
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "ProductOptionLink WHERE P_OPT_ProductID = " & numProductID)
	
	'Delete all product-attribute links
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "AttributeValues WHERE ATTRIBV_ProductID = " & numProductID)

	'Delete Product Images
	DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_products/" & numProductID), aryImageFileTypes, objFileSystem
	DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_products_large/" & numProductID), aryImageFileTypes, objFileSystem
End Sub

'Links the product numProductID to the categories in aryCategories. 
Sub ProductCategories(numProductID, aryCategories)

	'delete current links
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink WHERE PCAT_ProductID = " & numProductID)

	'create new links
	If IsArray(aryCategories) Then
		Dim numCount
		For numCount = 0 To UBound(aryCategories)
			Call ExecuteNonQuery("INSERT INTO tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink (PCAT_ProductID, PCAT_CategoryID) VALUES (" & numProductID & "," & aryCategories(numCount) & ")")
		Next
	End If
End Sub

'Links the product numProductID to the options groups in aryOptionGroups. 
Sub ProductOptionGroups(numProductID, aryOptionGroups)

	'delete current links
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "ProductOptionGroupLink WHERE P_OPTG_ProductID = " & numProductID)

	'create new links
	If IsArray(aryOptionGroups) Then
		Dim numCount
		For numCount = 0 To UBound(aryOptionGroups)
			Call ExecuteNonQuery("INSERT INTO tblCactuShop" & TABLE_PREFIX & "ProductOptionGroupLink (P_OPTG_ProductID, P_OPTG_OptionGroupID) VALUES (" & numProductID & "," & aryOptionGroups(numCount) & ")")
		Next
	End If
End Sub

'Links the version numVersionID to the options in aryOptions. 
Sub VersionOptions(numVersionID, aryOptions)

	'delete current links
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "VersionOptionLink WHERE V_OPT_VersionID = " & numVersionID)

	'create new links
	If IsArray(aryOptions) Then
		Dim numCount
		For numCount = 0 To UBound(aryOptions)
			Call ExecuteNonQuery("INSERT INTO tblCactuShop" & TABLE_PREFIX & "VersionOptionLink (V_OPT_VersionID, V_OPT_OptionID) VALUES (" & numVersionID & "," & aryOptions(numCount) & ")")
		Next
	End If
End Sub


'Recursive function to delete a category and all subcategories. If blnHardDelete = true, then it
'deletes all products (and versions) - if set to false, it only deletes them if the product is 
'only linked to this category and no others.
Sub DeleteCategory(numCategoryID, blnHardDelete, objFileSystem, objRecordSet, objRecordSet2)

	'Open objRecordSet to go through each product linked to this category.
	'Include in it a count of the other categories a product is in.
	strQuery = "SELECT tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_ProductID, COUNT(tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_ProductID) AS CatCount FROM tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink INNER JOIN tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink AS PCAT_Count ON tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_ProductID = PCAT_Count.PCAT_ProductID WHERE tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_CategoryID = " & numCategoryID & " GROUP BY tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_ProductID, tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_CategoryID"
	Call ExecuteRS(strQuery, objRecordSet)
	
	'Loop through each product and decide whether to delete it or not
	Do Until objRecordSet.EOF
		If blnHardDelete = True Or (blnHardDelete = False And Clng(objRecordSet(1)) = 1) Then

			'We can delete - We're either doing a hard delete, or a soft and this product is only is this category.
			DeleteProduct objRecordSet(0), objFileSystem, objRecordSet2
		
		End If
		objRecordSet.MoveNext
	Loop
	objRecordSet.Close
	
	'Delete category
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "Categories WHERE tblCactuShop" & TABLE_PREFIX & "Categories.CAT_ID = " & numCategoryID)
	
	'Delete all product links to this category
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink WHERE tblCactuShop" & TABLE_PREFIX & "ProductCategoryLink.PCAT_CategoryID = " & numCategoryID)

	'Delete all links between this category and others
	Call ExecuteNonQuery(strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "CategoryHierachy WHERE tblCactuShop" & TABLE_PREFIX & "CategoryHierachy.CH_ParentID = " & numCategoryID & " OR tblCactuShop" & TABLE_PREFIX & "CategoryHierachy.CH_ChildID = " & numCategoryID)

	'Delete Product Images
	aryImageFileTypes = Split(GetAppVar("allowedimages"), ",")
	DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_categories/" & numCategoryID), aryImageFileTypes, objFileSystem
	DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_categories_large/" & numCategoryID), aryImageFileTypes, objFileSystem
	
	'Loop through all sub-categories and save the ID
	'We do this so we can close the recordset before calling the function
	strSubCats = ""
	strQuery = "SELECT CAT_ID FROM tblCactuShop" & TABLE_PREFIX & "Categories c INNER JOIN tblCactuShop" & TABLE_PREFIX & "CategoryHierachy ch ON c.CAT_ID = ch.CH_ChildID WHERE ch.CH_ParentID = " & numCategoryID
	call ExecuteRS(strQuery, objRecordSet)
	Do Until objRecordSet.EOF
		strSubCats = strSubCats & objRecordSet("CAT_ID") & " "
		objRecordSet.MoveNext
	Loop
	objRecordSet.Close
	strSubCats = Trim(strSubCatS)
	
	'For each sub-category, recursively recall this function
	arySubCats = split(strSubCats, " ")
	For Each numSubCatID in arySubCats
		call DeleteCategory(numSubCatID, blnHardDelete, objFileSystem, objRecordSet, objRecordSet2)
	Next
	
End Sub


%>
