<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'***********************************************
'DISPLAY FUNCTIONS
'Code for displaying categories, products etc
'***********************************************


'-----------------------------------------------
'SHOW PRODUCTS
'Shows products in the passed objRecordSetProducts.
'LS: 107, 1490, 1458 +ShowVersions
'-----------------------------------------------
Sub ShowProducts(objRecordSetProducts, objRecordSetVersions, numRecordLimit, strDisplayType, strReturnTo, arySearchKeywords, numCategoryPosition, objTrail)
	
	'Useful application settings
	strAppUploadsFolder = GetAppVar("uploadsfolder")
	strAppShortenedFormatShowDesc = GetAppVar("shortenedformatshowdesc")
	numAppTruncateProductDescription = numSafe(GetAppVar("truncateproductdescription"))
	strAppConvertDescBreaks = GetAppVar("convertdescbreaks")
	strAppShortenedFormatShowVersions = GetAppVar("shortenedformatshowversions")
	strAppCatalogueOnly = GetAppVar("catalogueonly")
	strAppShowMoreDetailsLink = GetAppVar("showmoredetaillink")
	strAppDefaultVersionDisplay = GetAppVar("defaultversiondisplay")
	strAppPricesIncTax = GetAppVar("pricesinctax")
	strAppShowTaxDisplay = GetAppVar("showtaxdisplay")
	
	'If strDisplayType not specified, take default from config setting
	If strDisplayType = "" then strDisplayType = GetAppVar("defaultproddisplay")

	'Get semantic name for this format style
	Select Case strDisplayType
		Case "c": strStyle = "products_classicsearch"
		Case "s": strStyle = "products_shortened"
		Case "n": strStyle = "products_normal"
		Case "e": strStyle = "products_extended"
	End Select

	'Images
	Set objProductFileSystem = Server.CreateObject("Scripting.FileSystemObject")
	strProductPath = Server.MapPath(strAppUploadsFolder & "images_products/")
	strVersionPath = Server.MapPath(strAppUploadsFolder & "images_versions/")
	strVersionLargePath = Server.MapPath(strAppUploadsFolder & "images_versions_large/")
	aryFileTypes = Split(GetAppVar("allowedimages"), ",")

	blnAppShowVersions = (strAppCatalogueOnly = "n") and ((strDisplayType = "e") or (strDisplayType = "s" and strAppShortenedFormatShowVersions = "y"))

	'Open a div for the specials %>
	<div class="products <%= strStyle %>">
		<%
		If not (objRecordSetProducts.BOF and objRecordSetProducts.EOF) then
			numProductCount = 0
			
			'Build up the the parent IDs and names for linking. We get this
			'from the trail and then add on the current category (if we're in one)
			Set objProductLinks = New DynamicLinks
			objProductLinks.OnlyFakeIfPageIsFake = true
			If objTrail.Count = 0 then
				Redim aryParentNames(-1)
				strParentIDs = ""
			Else
				aryParentIDs = Split(objTrail.Parents, ",")
				Redim aryParentNames(objTrail.Count - 3)
				For i = 1 to objTrail.Count - 2
					aryParentNames(i-1) = objTrail.ItemName(i)
				Next
			End If			
			
			Do While (numProductCount < numRecordLimit or numRecordLimit = 0) And Not objRecordSetProducts.EOF
				numProductCount = numProductCount + 1
				
				'-----------------------------------------------
				'PULL OUT DATA FIELDS
				'-----------------------------------------------
				P_ID = objRecordSetProducts("P_ID")
				P_Name = objRecordSetProducts("P_Name" & CInt(numLanguageID))
				P_OrderVersionsBy = objRecordSetProducts("P_OrderVersionsBy")		
				P_Strapline = objRecordSetProducts("P_StrapLine" & CInt(numLanguageID))
				P_Desc = objRecordSetProducts("P_Desc" & CInt(numLanguageID))		
				P_VersionDisplayType = objRecordSetProducts("P_VersionDisplayType")
				P_Type = objRecordSetProducts("P_Type")
				strProductImage = GetFileLocation(strProductPath, P_ID, aryFileTypes, objProductFileSystem)
				
				'Are we display versions on this one?
				If P_VersionDisplayType = "d" then P_VersionDisplayType = strAppDefaultVersionDisplay
				blnShowVersions = strDisplayType <> "c" and blnAppShowVersions and (strDisplayType <> "s" or (P_VersionDisplayType = "o" or P_VersionDisplayType = "p" or P_VersionDisplayType = "l" or P_VersionDisplayType = "n"))
				
				'Description
				If numAppTruncateProductDescription > 0 and len(P_Desc) > numAppTruncateProductDescription then
					P_Desc = left(P_Desc, numAppTruncateProductDescription - 3) & "..."
				end if
				If strAppConvertDescBreaks = "y" then
					P_Desc = replace(P_Desc, vbcrlf, "<br />")
				end if
				If Not IsEmpty(arySearchKeywords) then
					P_Desc = Highlight(P_Desc, arySearchKeywords)
				End If
												
				'Set link to the product
				strProductURL = objProductLinks.GetProductLink(CAT_ID, CAT_Name, aryParentIDs, aryParentNames, P_ID, P_Name)
				If objTrail.PageHistory = "search" then
					strProductURL = strProductURL & "&amp;strPageHistory=search&amp;numSearchStartRecord=" & objTrail.SearchStartRecord
				End If
				
				strProductLink = "<a href=""" & strProductURL & """>"
				
				'-----------------------------------------------
				'MIN PRICING (ls #1490)
				'-----------------------------------------------
				If Not blnShowVersions and strAppShowPriceOnProductDisplay = "y" and strDisplayType <> "c" and strAppCatalogueOnly <> "y" then
					numMinPrice = objRecordSetProducts("MinPrice")
					numMinTaxRate =  objRecordSetProducts("MinTaxRate") / 100
					
					'Customer group pricing
					If SOFTWARE_IS_PRO Then
						numCustomerGroupMinPrice = GetCustomerGroupPriceForProduct(objRecordSetVersions, DB_CG_ID, P_ID)
						If numCustomerGroupMinPrice > 0 then
							numMinPrice = Min(numMinPrice, numCustomerGroupMinPrice)
						End If
					End If	
									
					'Display
					numMinPriceExTax = Round(numMinPrice * (1 / (1 + numMinTaxRate)), 2)	
					If strAppPricesIncTax = "y" then
						If strAppShowTaxDisplay = "y" then
							strMinPrice = objCurrency.Display(numMinPriceExTax, true, false) & " (" & GetString("ContentText_IncTax") & " " & objCurrency.Display(numMinPrice, true, false) & ")"
						Else
							strMinPrice = objCurrency.Display(numMinPrice, true, false)
						End if
					Else
						If strAppShowTaxDisplay = "y" then
							strMinPrice = objCurrency.Display(numMinPrice, true, false) & "  (+ " & (numMinTaxRate * 100) & "% " & GetString("ContentText_Tax") & ")"
						Else
							strMinPrice = objCurrency.Display(numMinPrice, true, false)
						End if
					End if
					if P_Type <> "s" then strMinPrice = GetString("ContentText_ProductPriceFrom") & strMinPrice
				else
					strMinPrice = ""
				End If


				'-----------------------------------------------
				'DISPLAY THE PRODUCT
				'-----------------------------------------------
				'If it's the start of a new line, close and re-open
				'the table
				response.Write "<div class=""product"" id=""product" & numProductCount & """>"

				'We want to display shortened format in different box style to regular format
				response.write "<div class=""box""><div class=""pad"">" & vbcrlf
				
				'Show product information
				If strDisplayType = "s" or strDisplayType = "c" then
					response.Write "<h2>" & strProductLink & P_Name & "</a></h2>" & vbcrlf
				else
					response.Write "<h2>" & P_Name & "</h2>" & vbcrlf
				end if
				
				if P_Strapline <> "" and strDisplayType <> "c" then
					response.write "<em class=""strapline"">" & P_Strapline & "</em>" & vbcrlf
				else
					response.write "<div class=""generalspace""></div>" & vbcrlf
				end if
				If strProductImage <> "" and strDisplayType <> "c" Then
					response.Write strProductLink & "<img src=""" & strTemplateShopFolder & strAppUploadsFolder & "images_products/" & strProductImage & """ alt=""" & WriteSafe(P_Name) & """ /></a>" & vbcrlf
				End if
				If strDisplayType <> "s" or strAppShortenedFormatShowDesc = "y" then 
					response.Write "<p>" & P_Desc & "</p>" & vbcrlf
				end if
				
				'Only show min price if we're not showing versions
				If strMinPrice <> "" then
					response.write "<div class=""minprice"">" & strMinPrice & "</div>" & vbcrlf
				End If
				
				'More details links/buttons

				If strDisplayType = "n" or strDisplayType =  "e" then %>
				<div class="extrainfolinks">
					<% If strAppShowMoreDetailsLink = "link" then
						'LS#107 and 1458
						If SOFTWARE_IS_PRO Then
							Call ShowCompare(false, P_ID, "prodtype", CAT_ID)
						End If
						response.Write "<div class=""moreinfo"">" & strProductLink & GetString("ContentText_ViewProductMoreDetail") & GetString("ContentText_ViewProductMoreDetail2") & "</a></div>" 

					else 
						If SOFTWARE_IS_PRO Then
							Call ShowCompare(true, P_ID, "prodtype", CAT_ID) 
						End If %> 
						<form action="<%= strTemplateShopFolder %>product.asp" method="get"><div>
							<%= objCactuSession.Form %>
							<%= objTrail.DeeperForm %>
							<input type="hidden" name="CAT_ID" value="<% =CAT_ID %>" />
							<input type="hidden" name="P_ID" value="<% =P_ID %>" />
							<input type="submit" name="btnProduct" class="submit" value="<% WriteSafeString("ContentText_ViewProductMoreDetail") %>" />
						</div></form><%
					end if %>
				</div>
				<% end if

				'Show versions
				If blnShowVersions then 
	
					'Create the 3 recordsets to go to the version display
					Set objRecordSetOptions = Server.CreateObject("ADODB.RecordSet")
					Set objRecordSetGroupPricing = Server.CreateObject("ADODB.RecordSet")
					Set objRecordSetVersions = Server.CreateObject("ADODB.RecordSet")				
					
					'Get version ordering
					strVersionsOrderBy = GetAppVar("sortversions")
					If P_OrderVersionsBy <> "" then strVersionsOrderBy = P_OrderVersionsBy
					If strVersionsOrderBy = "" then strVersionsOrderBy = "V_Name"
					if strVersionsOrderBy = "V_Name" or strVersionsOrderBy = "V_Desc" then strVersionsOrderBy = strVersionsOrderBy & CInt(numLanguageID)
					
					If P_VersionDisplayType = "g" or P_VersionDisplayType = "l" then
						'Doing an option group. We don't need to pull out the versions - just the option groups
						strQuery = "SELECT OPTG_ID, OPTG_Name" & CInt(numLanguageID) & ", OPTG_Desc" & CInt(numLanguageID) & ", OPTG_OptionDisplayType FROM tblCactuShop" & TABLE_PREFIX & "OptionGroups INNER JOIN tblCactuShop" & TABLE_PREFIX & "ProductOptionGroupLink ON tblCactuShop" & TABLE_PREFIX & "OptionGroups.OPTG_ID = tblCactuShop" & TABLE_PREFIX & "ProductOptionGroupLink.P_OPTG_OptionGroupID WHERE tblCactuShop" & TABLE_PREFIX & "ProductOptionGroupLink.P_OPTG_ProductID = " & P_ID & " ORDER BY P_OPTG_OrderByValue"
					Else	
						'Pull out all live versions for this product, and related tax info
						strQuery = "SELECT DISTINCT T_Taxrate, V_ID, V_Price, V_Weight, V_RRP, V_Tax, V_ProductID, V_CodeNumber, V_Quantity, V_Quantity, V_QuantityWarnLevel, "  & strVersionsOrderBy & " As OrderByBit, V_Name" & numLanguageID & ", " & castSQL("V_Desc" & numLanguageID) & " as V_Desc" & numLanguageID & ", MIN(QD_ID) As QuantityDiscount FROM (tblCactuShop" & TABLE_PREFIX & "Versions v INNER JOIN tblCactuShop" & TABLE_PREFIX & "TaxRates tr ON v.V_Tax = tr.T_ID) LEFT JOIN tblCactuShop" & TABLE_PREFIX & "QuantityDiscounts qd ON v.V_ID = qd.QD_VersionID WHERE V_Live = 'y' AND V_CustomerGroupID IN (0," & NumSafe(DB_CG_ID) & ") AND V_ProductID=" & P_ID & " AND V_Name" & numLanguageID & " <> '' GROUP BY T_Taxrate, V_ID, V_Price, V_Weight, V_RRP, V_Tax, V_ProductID, V_CodeNumber, V_Quantity, V_QuantityWarnLevel, " & strVersionsOrderBy & ", V_Name" & numLanguageID & ", " & castSQL("V_Desc" & numLanguageID) & " ORDER BY " & strVersionsOrderBy
					End If
					Call ExecuteRS(strQuery, objRecordSetVersions)
					
					'Customer group pricing
					If DB_CG_ID > 0 then
						strQuery2 = GetCustomerGroupPricesQuery(P_ID, strVersionsOrderBy)
						Call ExecuteRS(strQuery2, objRecordSetGroupPricing)
					End If
					
					'Show the versions
					Call ShowVersions(objRecordSetVersions, objRecordSetGroupPricing, objRecordSetOptions, P_ID, P_VersionDisplayType, strReturnTo, objProductFileSystem, arySearchKeywords, numCategoryPosition, objTrail, "")
					
					objRecordSetVersions.close
					If DB_CG_ID > 0 then objRecordSetGroupPricing.Close 
					
					'Kill 'em
					Set objRecordSetGroupPricing = Nothing
					Set objRecordSetOptions = Nothing 
				end if

				'Move on to the next record
				objRecordSetProducts.moveNext 
																
				'If we're at the end of the line, close the line tag
				response.write "</div></div></div>" & vbcrlf & vbcrlf


			loop '//product loop

		end if '// got specials
		Set objProductFileSystem = Nothing
		%>
	</div><div class="spacer"></div><% 

End Sub 


'-----------------------------------------------
' SHOW VERSIONS
' Displays the versions for a current product
' from passed recordset objRecordSetVersions
'
' This requires uses the following lstrings:
' 18, 55, 161, 265, 300, 648, 833, 1236, 1237, 1442, 1443, 1659, 1673. 1703, 1704, 1806, 1807, 1808
'-----------------------------------------------
Public numJscriptID 'This is defined outside the version as it needs to persist through multiple sub calls
Sub ShowVersions(objRecordSetVersions, objRecordSetGroupPricing, objRecordSetOptions, numProductID, strVersionDisplayType, strReturnTo, objVersionFileSystem, arySearchKeywords, numCategoryPosition, objTrail, strSelectedOptions)
	'-----------------------------------------------
	' SELECT THE TYPE OF DISPLAY
	' If the display type is set to 'default', then
	' grab the default display type from the config
	' settings.
	'-----------------------------------------------
	'Get useful app settings
	strCatalogueOnly = GetAppVar("catalogueonly")
	strAppPricesIncTax = GetAppVar("pricesinctax")
	strAppAddToBasket = GetAppVar("addtobasketdisplay")
	strAppShowTaxDisplay = GetAppVar("showtaxdisplay")
	strAppShowRRP = GetAppVar("showrrponversiondisplay")
	strAppShowWeight = GetAppVar("showweightonversiondisplay")
	strAppShowStock = GetAppVar("showstockonversiondisplay")
	blnDoQuantityDiscounts = (GetAppVar("quantitydiscounts") > 0)

	strVersionPath = Server.MapPath(strTemplateShopFolder & strAppUploadsFolder & "images_versions/")
	strVersionLargePath = Server.MapPath(strTemplateShopFolder & strAppUploadsFolder & "images_versions_large/")

	'Calculate the number of columns shown on a version table
	'Basic consists of name, version code, Price * 2	(note: price is always 2 regardless of display type).
	'Additional 3 columns based on config
	numBaseVersionColumns = 4		
	numVersionColumns = numBaseVersionColumns
	if strAppShowRRP = "y" then numVersionColumns = numVersionColumns + 1
	if strAppShowWeight = "y" then numVersionColumns = numVersionColumns + 1
	if strAppShowStock = "y" then numVersionColumns = numVersionColumns + 1

	'Proceed to show version information if we're not in catalogue mode
	If strCatalogueOnly <> "y" then
		'Get whether there's only one version
		response.Write vbcrlf & "<div class=""versions"">" & vbcrlf 
		numTotalVerRecs = objRecordSetVersions.RecordCount
		blnOnlyOneVersion = (numTotalVerRecs = 1)

		'If the display type is default, or it's set to 'none' but there's not one
		'version, then get the default from the config settings
		If strVersionDisplayType = "d" or (strVersionDisplayType = "n" and not blnOnlyOneVersion) then strVersionDisplayType = GetAppVar("defaultversiondisplay")

		'If we're still set to none when we shouldn't, use rows
		If strVersionDisplayType = "n" and not blnOnlyOneVersion then strVersionDisplayType = "r"
		strAppAllowPurchaseOutOfStock = GetAppVar("allowpurchaseoutofstock")
		
		'Set return hidden fields and querystring
		strReturnQueryString = "strReturnTo=" & strReturnTo & "&amp;numReturnCAT_ID=" & CAT_ID & "&amp;numReturnP_ID=" & numProductID & "&amp;numReturnRecordPosition=" & numCategoryPosition
		strReturnHiddenFields = "<input type=""hidden"" name=""strReturnTo"" value=""" & strReturnTo & """ />" &_
			"<input type=""hidden"" name=""numReturnCAT_ID"" value=""" & CAT_ID & """ />" &_
			"<input type=""hidden"" name=""numReturnP_ID"" value=""" & numProductID & """ />" &_
			"<input type=""hidden"" name=""numReturnRecordPosition"" value=""" & numCategoryPosition & """ />"
			
		'-----------------------------------------------
		' SHOW VERSIONS AS OPTION GROUP
		' This ignores all the version information, and
		' shows option groups this product is linked
		' to. On submission, the basket works out
		' which version was selected. If this is the 
		' case the objRecordSetVersions contains the option
		' groups, not the version information.
		' l shows the groups in a Line, g shows it 
		' in groups layout
		'-----------------------------------------------
		If (strVersionDisplayType = "l" or strVersionDisplayType = "g") then 
			'Initialise the variables
			numTotalOptionGroups = objRecordSetVersions.RecordCount 
			numOptionGroupCount = 0 
			strOptionMatrix = "" 
			numPriceModifier = 0
			strBracketSQL = ""
			strJoinSQL = ""
			strWhereSQL = ""
			numOptCombinationCount = 0
			blnDoingLine = (strVersionDisplayType = "l")

			'-----------------------------------------------
			'PULL OUT THE BASE VERSION
			'The base version holds various base information
			'-----------------------------------------------
			strQuery = "SELECT DISTINCT T_TaxRate, V_ID, V_Price, V_Weight, V_Quantity, V_QuantityWarnLevel, V_Live, V_RRP, MIN(QD_ID) As QuantityDiscount FROM (tblCactuShop" & TABLE_PREFIX & "Versions v INNER JOIN tblCactuShop" & TABLE_PREFIX & "TaxRates tr ON v.V_Tax = tr.T_ID) LEFT JOIN tblCactuShop" & TABLE_PREFIX & "QuantityDiscounts qd ON v.V_ID = qd.QD_VersionID WHERE V_ProductID = " & numProductID & " AND V_Type IN ('o','b') GROUP BY T_TaxRate, V_ID, V_Price, V_Weight, V_Quantity, V_QuantityWarnLevel, V_Live, V_RRP"
			Call ExecuteRS(strQuery, objRecordSetOptions)
			If objRecordSetOptions.BOF and objRecordSetOptions.EOF then
				'This shouldn't happen - product unavailable message
				Call EndPage()
				response.Redirect("error.asp?" & strSessionQS & "ID=nobaseversion&product=" & numProductID)
			else
				V_ID = objRecordSetOptions("V_ID")
				V_RRP = objRecordSetOptions("V_RRP")
				V_Weight = objRecordSetOptions("V_Weight")
				T_TaxRate = objRecordSetOptions("T_TaxRate")
				V_Quantity = objRecordSetOptions("V_Quantity")
				V_QuantityWarnLevel = objRecordSetOptions("V_QuantityWarnLevel")
				V_Live = objRecordSetOptions("V_Live")
				
				If SOFTWARE_IS_PRO Then
					V_Price = GetSpecialPrice(objRecordSetOptions, "V_Price", objRecordSetGroupPricing, "CGP_Price")
				Else
					V_Price = objRecordSetOptions("V_Price")
				End If
				
				If SOFTWARE_IS_PRO Then
					If Not IsNull(objRecordSetOptions("QuantityDiscount")) then
						blnShowStar = true
						blnGotOneGroupDiscount = true
					Else
						blnShowStar = false
						blnGotOneGroupDiscount = false
					End If
				End If
				blnOutOfStock = Not (V_Live="y" or V_Quantity > 0 or V_QuantityWarnLevel = 0 or strAppAllowPurchaseOutOfStock = "y")
			end if
			objRecordSetOptions.close		
			
			'Don't both processing the option groups if we're out of stock
			If Not blnOutOfStock then	
					
				'We keep a loop counter every time we show the information to pass to the javascript
				numJscriptID = numJscriptID + 1
			
				'Pass the base V_ID in the option matrix
				strOptionMatrix = "<input type=""hidden"" name=""V_ID"" value=""" & V_ID & """ />"
				
				'Set various loop values blank
				strStockSelectSQL = ""
				strBracketSQL = ""
				strStockJoinSQL = ""
				strStockOrderBySQL = ""
				numStockGroupCount = 0
							
				'-----------------------------------------------
				'BUILD UP ALL THE OPTION GROUPS
				'Build up the strOptionMatrix string with the
				'option group selects.
				'-----------------------------------------------
				Do While Not objRecordSetVersions.EOF
					'Pull out all the option group information
					numOptionGroupCount = numOptionGroupCount + 1
					numOptionCount = 0
					OPTG_ID = objRecordSetVersions("OPTG_ID")
					OPTG_Name = objRecordSetVersions("OPTG_Name" & CInt(numLanguageID)) 
					OPTG_Desc = objRecordSetVersions("OPTG_Desc" & CInt(numLanguageID))
					OPTG_OptionDisplayType = objRecordSetVersions("OPTG_OptionDisplayType")
					
					'If we're doing a line, then we can't display option boxes - force it to dropdown
					If blnDoingLine then
						If OPTG_OptionDisplayType = "o" then OPTG_OptionDisplayType = "d"
					End If
					
					'Hidden form value to send the option groups being used
					strOptionMatrix = strOptionMatrix & "<div class=""option""><input type=""hidden"" name=""numOptionGroupIDs"" value=""" & OPTG_ID & """ />" & vbcrlf
					
					'Show title of option group if reqd.
					strOptionMatrix = strOptionMatrix & "<label class=""optiontitle"" for=""op" & numJscriptID & "_OPT_ID" & OPTG_ID & "_1"">"
					strOptionMatrix = strOptionMatrix & "<strong>" & OPTG_Name & "</strong>"
					If OPTG_Desc & "" <> "" and not blnDoingLine then 
						strOptionMatrix = strOptionMatrix & OPTG_Desc
					End If
					strOptionMatrix = strOptionMatrix & "</label><div>" & vbcrlf
					
					'Add in a select box for the dropdown
					If OPTG_OptionDisplayType = "d" then
						strOptionMatrix = strOptionMatrix & "<select id=""op" & numJscriptID & "_OPT_ID" & OPTG_ID & "_1"" name=""OPT_ID" & OPTG_ID & """ onchange=""javascript:checkStock(" & numJscriptID & ",oos" & numJscriptID & ");"">" & vbcrlf
					End If
						
					'Pull out all the options in this group
					strQuery = "SELECT OPT_ID, OPT_Name" & CInt(numLanguageID) & ", OPT_CheckBoxValue, P_OPT_PriceChange, P_OPT_Selected FROM tblCactuShop" & TABLE_PREFIX & "Options INNER JOIN tblCactuShop" & TABLE_PREFIX & "ProductOptionLink ON tblCactuShop" & TABLE_PREFIX & "Options.OPT_ID = tblCactuShop" & TABLE_PREFIX & "ProductOptionLink.P_OPT_OptionID WHERE OPT_OptionGroupID = " & OPTG_ID & " AND P_OPT_ProductID = " & numProductID & " ORDER BY P_OPT_OrderByValue"
					Call ExecuteRS(strQuery, objRecordSetOptions)

					'Bug fix 6.045
					'If no option is setup as default, then it is possible for the user
					'to submit the page without an option selected, which corrupts the
					'session and results in nasty page errors. If the store owner has
					'set a default, this doesn't happen, but it's possible to forget to
					'do that. As a fix that will apply retrospectively to old data too, we
					'will preset the first radio button to 'checked'. If no others are
					'set as default or otherwise selected, this first one shows up checked.
					'If ones after this are set to checked because they are default or
					'because they are preset by the link from basket, then these will
					'override the first checkbox. Setting two radio buttons to 'checked'
					'sounds like it should be invalid HTML, but it passes the w3c validator.

					strCheckFirstForSafety = " checked=""checked"""

					Do while not objRecordSetOptions.EOF
						'Pull out all option information
						numOptionCount = numOptionCount + 1
						OPT_ID = objRecordSetOptions("OPT_ID")
						OPT_Name = objRecordSetOptions("OPT_Name" & CInt(numLanguageID))
						OPT_CheckBoxValue = objRecordSetOptions("OPT_CheckBoxValue")
						P_OPT_PriceChange = objRecordSetOptions("P_OPT_PriceChange")
						
						'Decide What to select. If we've got selections, only select if
						'it's in that array. Otherwise, select based on the database
						If strSelectedOptions <> "" and strSelectedOptions <> "0" then
							blnSelected = (instr("," & strSelectedOptions & ",", "," & OPT_ID & ",") > 0)
						Else
							blnSelected = (objRecordSetOptions("P_OPT_Selected") = "y")
						End If
						
						'If price has changed, append it on to the name field
						If P_OPT_PriceChange <> 0 then
							If P_OPT_PriceChange > 0 then strSign = "+" else strSign = "-"
							OPT_Name = OPT_Name & " (" & strSign & " " & objCurrency.Display(abs(P_OPT_PriceChange), true, false) & ")"
						End If

						'Select the option if flagged				
						If blnSelected then 
							If OPTG_OptionDisplayType = "d" then
								'For a SELECT dropdown
								strSelectedText = " selected=""selected""" 
							Else
								'For radio or checkbox
								strSelectedText = " checked=""checked"""
							end if
						else 
							strSelectedText = ""
						end if
						
						'Write out option, move on to next
						If OPTG_OptionDisplayType = "d" then
							'Do the dropdown option
							strOptionMatrix = strOptionMatrix & "<option value=""" & OPT_ID & """" & strSelectedText & ">" & OPT_Name & "</option>" & vbcrlf
						ElseIf OPTG_OptionDisplayType = "c" then
							'Do a checkbox - if it's the 'no' value, then
							'do a hidden field
							If OPT_CheckBoxValue = "n" then
								strOptionMatrix = strOptionMatrix & "<input type=""hidden"" name=""NOCHECK_OPT_ID" & OPTG_ID & """ value=""" & OPT_ID & """" & strSelectedText & " />" & vbcrlf
							Else
								strOptionMatrix = strOptionMatrix & "<input type=""checkbox"" class=""checkbox"" id=""op" & numJscriptID & "_OPT_ID" & OPTG_ID & "_1"" name=""OPT_ID" & OPTG_ID & """ value=""" & OPT_ID & """" & strSelectedText & " onclick= ""javascript:checkStock(" & numJscriptID & ",oos" & numJscriptID & ");"" onchange=""javascript:checkStock(" & numJscriptID & ",oos" & numJscriptID & ");"" /><label for=""op" & numJscriptID & "_OPT_ID" & OPTG_ID & "_1"">" & OPT_Name & "</label>" & vbcrlf
							End If
						Else
							'Do a radio button
							strOptionMatrix = strOptionMatrix & "<span class=""radiooptions""><input" & strCheckFirstForSafety & " class=""radio"" type=""radio"" id=""op" & numJscriptID & "_OPT_ID" & OPTG_ID & "_" & numOptionCount & """ name=""OPT_ID" & OPTG_ID & """ value=""" & OPT_ID & """" & strSelectedText & "onclick=""javascript:checkStock(" & numJscriptID & ",oos" & numJscriptID & ");"" onchange=""javascript:checkStock(" & numJscriptID & ",oos" & numJscriptID & ");"" /><label for=""op" & numJscriptID & "_OPT_ID" & OPTG_ID & "_" & numOptionCount & """>" & OPT_Name & "</label></span>" & vbcrlf
						End If

						strCheckFirstForSafety = "" 'set to blank, this way it only writes 'checked' for first radio button

						objRecordSetOptions.MoveNext

					Loop
					objRecordSetOptions.Close
					
					'Close select, move on to next group
					If OPTG_OptionDisplayType = "d" then
						strOptionMatrix = strOptionMatrix & "</select>" & vbcrlf
					End If
					
					strOptionMatrix = strOptionMatrix & "</div></div>" & vbcrlf
					
					'Build up stock query (see below for details)
					If numStockGroupCount >= 1 then
						strStockOrderBySQL = strStockOrderBySQL  & ", "
						strStockSelectSQL = strStockSelectSQL & ", "
						strStockWhereSQL = strStockWhererSQL & " AND opt" & numStockGroupCount & ".V_OPT_OptionID > opt" & numStockGroupCount - 1 & ".V_OPT_OptionID"
					End If
					strStockSelectSQL = strStockSelectSQL & "opt" & numStockGroupCount & ".V_OPT_OptionID As id" & numStockGroupCount
					strBracketSQL = strBracketSQL & "("
					strStockJoinSQL = strStockJoinSQL & " INNER JOIN tblCactuShop" & TABLE_PREFIX & "VersionOptionLink opt" & numStockGroupCount & " ON tblCactuShop" & TABLE_PREFIX & "Versions.V_ID = opt" & numStockGroupCount & ".V_OPT_VersionID)"
					strStockOrderBySQL = strStockOrderBySQL & "opt" & numStockGroupCount & ".V_OPT_OptionID"
					numStockGroupCount = numStockGroupCount + 1
					
					'Next option group
					objRecordSetVersions.MoveNext 
				Loop 
			End If '// out of stock

			
			'Pull out all combinations that aren't available for this product. 
			'We store this data in javascript and, when a choice is selected, 
			'we check in a function see if it's an item here (if it is, we display a out-of-stock message).
			'This is a rather complicated query - try writing out the resultant query and pasting in to a dbm ;)
			If numStockGroupCount > 0 then
				'Stock combinations that aren't allowed either aren't live, are specific to a customer group we're not in, 
				'have a blank version name for this language, or is out of stock.
				strNotAllowedWhereClause = " (tblCactuShop" & TABLE_PREFIX & "Versions.V_Live <> 'y') OR (V_CustomerGroupID NOT IN (0," & NumSafe(DB_CG_ID) & ")) OR (V_Name" & CInt(numLanguageID)  & " = '')"
				If strAppAllowPurchaseOutOfStock <> "y" Then
					strNotAllowedWhereClause = strNotAllowedWhereClause & " OR (tblCactuShop" & TABLE_PREFIX & "Versions.V_QuantityWarnLevel>0 AND tblCactuShop" & TABLE_PREFIX & "Versions.V_Quantity<=0)"
				End If
				
				strQuery = "SELECT " & strStockSelectSQL & " FROM " & strBracketSQL & "tblCactuShop" & TABLE_PREFIX & "Versions" & strStockJoinSQL & " WHERE (tblCactuShop" & TABLE_PREFIX & "Versions.V_ProductID=" & numProductID & ") AND (" & strNotAllowedWhereClause & ") AND (1=1" & strStockWhereSQL & ") ORDER BY " & strStockOrderBySQL
				Call ExecuteRS(strQuery, objRecordSetOptions)
				numTotalOutOfStock = objRecordSetOptions.RecordCount
				numCurrOutOfStock = 0
				ReDim aryOutOfStock(numTotalOutOfStock - 1)
				Do While Not objRecordSetOptions.EOF
					strOutOfStockItem = ""
					For i = 0 to numStockGroupCount - 1
						strOutOfStockItem = strOutOfStockItem & "-" & objRecordSetOptions("id" & i)
					Next
					aryOutOfStock(numCurrOutOfStock) = Mid(strOutOfStockItem, 2)
					numCurrOutOfStock = numCurrOutOfStock + 1
					objRecordSetOptions.MoveNext
				Loop
				objRecordSetOptions.Close
			end if

			'Display price line (see functions.asp)
			Call ShowPriceLine(Round(V_Price,2), T_Taxrate / 100, V_RRP, blnShowStar, strAppPricesIncTax, strAppShowTaxDisplay, strAppShowRRP, V_Weight)
			if blnOutOfStock then

				response.Write "<div class=""boxinset options addtobasket"">" & vbcrlf
				response.write "<img src=""" & strTemplateImagesFolder & "outofstock.gif"" alt="""" />" & vbcrlf
				response.Write "</div>" & vbcrlf

			else 
				'Start option group form
				If not blnDoingLine then
					'Don't really need a header of 'options' over options, but if you really want to can activate line below
					'response.Write "<h4 class=""boxheader"">" & GetString("ContentText_ProductOptions") & "</h4>" & vbcrlf
				End If	
				response.Write "<div class=""" & IIf(blnDoingLine, "boxinset ", "") & "optiongroups optiongroups_" & IIf(blnDoingLine, "line", "block") & """ id=""optiongroups" & numJScriptID & """>" & vbcrlf
				response.Write "<form method=""get"" id=""options" & numJscriptID & """ action=""" & strTemplateShopFolder & "basket.asp"" onsubmit=""checkStock(" & numJscriptID & ",oos" & numJscriptID & ");""><div>" & vbcrlf
				response.Write objCactuSession.Form & vbcrlf
				response.Write objTrail.Form & vbcrlf
				response.Write strReturnHiddenFields & vbcrlf
				response.write "<input type=""hidden"" name=""numLineCount"" value=""1"" />" & vbcrlf
				response.Write "<input type=""hidden"" name=""strAction"" value=""add"" />" & vbcrlf

				'Options matrix
				If Not blnDoingLine then 
					response.Write "<div class=""boxinset options"">" & vbcrlf
					response.Write strOptionMatrix
					response.Write "</div>" & vbcrlf
				End If
				
				'Add to basket
				response.Write "<div class=""" & IIf(blnDoingLine, "", "boxinset ") & "addtobasket"" id=""addtobasketline" & numJscriptID & """>" & vbcrlf
				Select Case strAppAddToBasket
					Case "dropdown" 
						'Dropdown
						response.Write "<select name=""Q1"">" & vbcrlf
						for numCounter = 1 to GetAppVar("addtobasketdropdownmax")
							response.Write "<option value=""" & numCounter & """>" & numCounter & "</option>" & vbcrlf
						next
						response.write "</select>" & vbcrlf

					Case "textbox"
						'Textbox
						response.Write "<input class=""small"" size=""3"" type=""text"" name=""Q1"" />" & vbcrlf
						
					Case Else
						'Button or link - must display as button because the information 
						'is passed through a form
						response.write "<input type=""hidden"" name=""Q1"" value=""1"" />" & vbcrlf
				End Select
				response.Write "<input class=""submit"" type=""submit"" value=""" & GetSafeString("FormButton_Add") & """ name=""submit"" />" & vbcrlf
				response.Write "</div>" & vbcrlf
				
				'Out of stock line
				response.Write "<div class=""" & IIf(blnDoingLine, "", "boxinset ") & "addtobasket"" id=""outofstockline" & numJscriptID & """ style=""display: none; visibility: hidden"">" & vbcrlf
				response.Write "<img src=""" & strTemplateImagesFolder & "outofstock.gif"" alt="""" />" & vbcrlf
				response.Write "</div>" & vbcrlf
											
				'Options matrix
				If blnDoingLine then 
					response.Write strOptionMatrix
				End If
				
				'out of stock message
				response.write "<span class=""outofstockmessage"" id=""outofstockmessage" & numJscriptID & """ style=""visibility: hidden; display: none""><em>" & GetString("ContentText_ComboOutOfStock") & "</em></span>" & vbcrlf
				
				'Javascript for options selection
				response.Write "<script type=""text/javascript"">" & vbcrlf
				response.write "var oos" & numJscriptID & " = new Array();" & vbcrlf
				For i = 0 to numTotalOutOfStock - 1
					response.Write "oos" & numJscriptID & "[" & i & "]='" & aryOutOfStock(i) & "';" & vbcrlf
				Next
				response.Write "checkStock(" & numJscriptID & ",oos" & numJscriptID & ");" & vbcrlf
				
				response.Write "checkStock(" & numJscriptID & ",oos" & numJscriptID & ");" & vbcrlf
				
				response.Write "</script>" & vbcrlf




				response.Write "</div></form></div>" & vbcrlf
				
			end if 

		'-----------------------------------------------
		' SHOW VERSIONS AS ONE DROPDOWN / NO DISPLAY
		' Displays versions in a single dropdown, or
		' not version display at all
		'-----------------------------------------------
		elseIf ListSafe(strVersionDisplayType, "o,p,n", "") <> "" then %>
			<form method="get" action="<%= strTemplateShopFolder %>basket.asp"><div>
				<%= objCactuSession.Form %>
				<%= objTrail.Form %>
				<%= strReturnHiddenFields %>			
				<input type="hidden" name="numLineCount" value="1" />
				<input type="hidden" name="strAction" value="add" />
				
				<%
				'-----------------------------------------------
				'PRICE WILL NOT SHOWN IN DROPDOWN, SHOW IT BEFORE
				'-----------------------------------------------
				If Not strVersionDisplayType = "p" then 
					numRRP = objRecordSetVersions("V_RRP")
					numTax = objRecordSetVersions("T_Taxrate") / 100
					if objRecordSetVersions.RecordCount = 1 then V_Weight = objRecordSetVersions("V_Weight")
					
					If SOFTWARE_IS_PRO Then
						numPrice = GetSpecialPrice(objRecordSetVersions, "V_Price", objRecordSetGroupPricing, "CGP_Price")
					Else
						numPrice = objRecordSetVersions("V_Price")
					End If		
					
					'Decide whether to show a group-discount star
					If SOFTWARE_IS_PRO Then
						If Not IsNull(objRecordSetVersions("QuantityDiscount")) then
							blnShowStar = true
							blnGotOneGroupDiscount = true
						Else
							blnShowStar = false
						End If
					End If
					
					
					Call ShowPriceLine(numPrice, numTax, numRRP, blnShowStar, strAppPricesIncTax, strAppShowTaxDisplay, strAppShowRRP, V_Weight)
				End If
					
				'-----------------------------------------------
				'SHOW VERSIONS WITHIN A DROPDOWN MENU
				'-----------------------------------------------
				strDropDown = ""
				if strVersionDisplayType = "n" then 
					blnOutOfStock = Not (objRecordSetVersions("V_Quantity") > 0 or objRecordSetVersions("V_QuantityWarnLevel") = 0 or strAppAllowPurchaseOutOfStock = "y")
				Else
					do while not objRecordSetVersions.EOF
					
						'Display if it's in stock, quantity tracking is turned off, or 
						'customers can purchase out of stock items
						blnOutOfStock = Not (objRecordSetVersions("V_Quantity") > 0 or objRecordSetVersions("V_QuantityWarnLevel") = 0 or strAppAllowPurchaseOutOfStock = "y")
						If not blnOutOfStock then
							'Get price. Display type dependant on tax settings
							If SOFTWARE_IS_PRO Then
								numPrice = GetSpecialPrice(objRecordSetVersions, "V_Price", objRecordSetGroupPricing, "CGP_Price")
							Else
								numPrice = objRecordSetVersions("V_Price")
							End If								
							
							numTax = objRecordSetVersions("T_Taxrate")/100
							numPriceExTax = Round(numPrice * (1/(1 + numTax)),2)

							'Set price to display
							If strAppPricesIncTax = "y" then
								If strAppShowTaxDisplay = "y" then
									strPriceToShow = objCurrency.Display(numPriceExTax, true, false) & "  (" & GetString("ContentText_IncTax") & " " & objCurrency.Display(numPrice, true, false) & ")"
								Else
									strPriceToShow = objCurrency.Display(numPrice, true, false)
								End if
							Else
								If strAppShowTaxDisplay = "y" then
									strPriceToShow = objCurrency.Display(numPrice, true, false) & "  (+ " & (numTax * 100) & "% " & GetString("ContentText_Tax") & ")"
								Else
									strPriceToShow = objCurrency.Display(numPrice, true, false)
								End if
							End if
							
							'Decide whether to show a group-discount star
							If SOFTWARE_IS_PRO Then
								If Not IsNull(objRecordSetVersions("QuantityDiscount")) then
									strPriceToShow = strPriceToShow & "*"
									blnGotOneGroupDiscount = true
								End If
							End If
							
							'Build up the text to display in the option
							strTextToShow = objRecordSetVersions("V_Name" & CInt(numLanguageID))
							
							If strAppShowWeight = "y" and NumSafe(objRecordSetVersions("V_Weight")) > 0 then 
								strTextToShow = strTextToShow & " - " & NumSafe(objRecordSetVersions("V_Weight")) & " " & GetAppVar("weightunit")
							End If
							
							If strVersionDisplayType = "p" then 
								strTextToShow = strTextToShow & " - " & strPriceToShow
							End If			
							
							'Write out the option							
							If objRecordSetVersions("V_ID") = NumSafe(V_ID) then selectedtext = " selected=""selected""" else selectedtext = ""
							strDropDown = strDropDown & "<option value=""" & objRecordSetVersions("V_ID") & """" & selectedtext & ">" & strTextToShow & "</option>" & vbcrlf
						end if
						objRecordSetVersions.MoveNext			
					Loop
				End If
				
				response.Write "<div class=""boxinset line""><div class=""addtobasket"">" & vbcrlf
				If (strVersionDisplayType = "n" and blnOutOfStock) or (strVersionDisplayType <> "n" and strDropDown = "") then 
					'Out of stock
					response.write "<img class=""outofstock"" src=""" & strTemplateImagesFolder & "outofstock.gif"" alt="""" />" & vbcrlf
				Else
					'Display the dropdowns and the 'add to basket' button 
					If strVersionDisplayType = "n" then
						response.Write "<input type=""hidden"" name=""V1"" value=""" & objRecordSetVersions("V_ID") & """ />" & vbcrlf
					Else 
						response.write "<select name=""V1"">" & vbcrlf & strDropDown & "</select>" & vbcrlf
						
						'If we're showing a dropdown, we can't display the link type
						If strAppAddToBasket = "link" then strAppAddToBasket = "button"
						
					End If
					
					'Show the quantities, dependant on config setting
					'Note that type Link is not supported, because this can't work without a form
					Select Case strAppAddToBasket
						Case "dropdown"  %>
							<select name="Q1"><%
								for numCounter = 1 to GetAppVar("addtobasketdropdownmax") %>
								<option value="<% =numCounter %>"><% =numCounter %></option><% 
								next %>
							</select>
							<input class="submit" type="submit" value="<% WriteSafeString("FormButton_Add") %>" name="submit" />
						
						<% Case "textbox" %>
							<input class="small" size="3" type="text" name="Q1" />
							<input class="submit" type="submit" value="<% WriteSafeString("FormButton_Add") %>" name="submit" />
						
						<% Case "link" %>
							<span class="small"><a href="<%= strTemplateShopFolder %>basket.asp?<%= objCactuSession.QS %><%= objTrail.QS %>numLineCount=1&amp;V1=<%= objRecordSetVersions("V_ID") %>&amp;Q1=1&amp;strAction=add&amp;<% =strReturnQueryString %>"><% WriteSafeString("ContentText_AddToBasket") %></a></span>
							
						<% Case Else
							'Button or link - must display as button because the information 
							'is passed through a form %>
							<input type="hidden" name="Q1" value="1" />
							<input class="submit" type="submit" value="<% WriteSafeString("FormButton_Add") %>" name="submit" />
					
					<%	End Select
				End If '// No items exist in dropdown
				response.Write "</div></div>" & vbcrlf
				%>		
			</div></form>


		<% 
		'-----------------------------------------------
		' SHOW VERSIONS IN INDIVIDUAL ROWS
		' This is the standard display that shows each
		' version on a seperate row of a table. 
		'
		' It displays version name, code number, weight
		' (optional), RRP (optional), Price & Tax and 
		' Add to button link.
		'
		' The Price & Tax columns that are displayed is
		' dependant on your tax settings. 
		'
		' If you want to move around the columns, make
		' sure you change the header bit at the top
		' and the display bit in the recordset loop.
		'-----------------------------------------------
		else 
			'ls#1703
			response.Write "<div class=""versionstable""><table summary=""" & GetSafeString("ContentText_VersionTableSummary") & """>" & vbcrlf
				'-----------------------------------------------------
				' COLUMNS
				'-----------------------------------------------------
				response.Write "<colgroup class=""col_name""></colgroup>" & vbcrlf
				response.Write "<colgroup class=""col_info"" span=""" & numVersionColumns - numBaseVersionColumns & """></colgroup>" & vbcrlf
				response.Write "<colgroup class=""col_price"" span=""" & IIf(strAppShowTaxDisplay = "y", 2, 1) & """></colgroup>" & vbcrlf
				response.Write "<colgroup class=""col_addtobasket""></colgroup>" & vbcrlf
				
				'-----------------------------------------------------
				' TABLE HEADERS
				'-----------------------------------------------------
				response.write "<thead>" & vbcrlf
				response.write "<tr class=""header"">" & vbcrlf
					response.Write "<th class=""name""></th>" & vbcrlf
					
					'Weight, RRP And stock
					if strAppShowWeight = "y" then		'Weight column
						response.write "<th class=""weight"">" & GetString("ContentText_Weight") & "</th>" & vbcrlf
					end if
					if strAppShowRRP = "y" then		'RRP
						response.Write "<th class=""RRP"">" & GetString("ContentText_RRP") & "</th>" & vbcrlf
					end if
					if strAppShowStock = "y" then		'Stock level
						response.Write "<th class=""stock"">" & GetString("ContentText_Stock") & "</th>" & vbcrlf
					end if

					'Price headers
					If strAppPricesIncTax = "y" then
						If strAppShowTaxDisplay = "y" then
							response.Write "<th class=""price_1"">" & GetString("ContentText_ExTax") & "</th>" & vbcrlf
							response.Write "<th class=""price_2"">" & GetString("ContentText_IncTax") & "</th>" & vbcrlf
						Else
							response.Write "<th class=""price"" colspan=""2"">" & GetString("ContentText_IncTax") & "</th>" & vbcrlf
						End if
					Else
						If strAppShowTaxDisplay = "y" then
							response.Write "<th class=""price_1"">" & GetString("ContentText_Price") & "</th>" & vbcrlf
							response.Write "<th class=""price_2"">" & GetString("ContentText_Tax") & "</th>" & vbcrlf
						Else
							response.write "<th class=""price"" colspan=""2"">" & GetString("ContentText_Price") & "</th>" & vbcrlf
						End if
					End if
					
					'Add to basket column
					response.Write "<th class=""addtobasket""></th>" & vbcrlf
				response.Write "</tr>" & vbcrlf
				response.Write "</thead>" & vbcrlf
				
				'-----------------------------------------------------
				' SHOW TABULAR DATA
				'-----------------------------------------------------
				numVersionRowCount = 0
				blnGotOneGroupDiscount = false
				response.Write "<tbody>" & vbcrlf
				do while not objRecordSetVersions.EOF 
					numVersionRowCount = numVersionRowCount + 1
					
					'Get version price
					If SOFTWARE_IS_PRO Then
						numPrice = GetSpecialPrice(objRecordSetVersions, "V_Price", objRecordSetGroupPricing, "CGP_Price")
					Else
						numPrice = objRecordSetVersions("V_Price")
					End If						
					
					numTax = objRecordSetVersions("T_Taxrate")/100
					numPriceExTax = Round(numPrice * (1/(1 + numTax)),2)
					
					'Decide whether to show a group-discount star
					If SOFTWARE_IS_PRO Then
						If Not IsNull(objRecordSetVersions("QuantityDiscount")) then
							blnGotOneGroupDiscount = true
							strGroupDiscount = "*"
						Else
							strGroupDiscount = ""
						End If
					End If
					
					'Set row class - alternates, highlights
					strRowHTML = ""
					If objRecordSetVersions("V_ID") = Clng(V_ID) then 
						strRowHTML = " class=""highlight"""
					ElseIf numVersionRowCount mod 2 = 1 then
						strRowHTML = " class=""alt"""
					end if 
					
					'Description
					strDescriptionHTML = ""
					V_Desc = objRecordSetVersions("V_Desc" & CInt(numLanguageID)) & ""
					
					if V_Desc <> "" then 
						'If we're running on access, we need to pull out the version decsription again. This
						'is because access sucks and only returns the first 255 characters due to the GROUP BY
						'in the version query.
						If Len(V_Desc) < 256 then
							V_Desc = ExecuteScalar("SELECT V_DESC" & numLanguageID & " FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_ID=" & objRecordSetVersions("V_ID"))
						End If
						If GetAppVar("convertdescbreaks") = "y" then
							V_Desc = replace(V_Desc, vbcrlf, "<br />")
						end if													
						strDescriptionHTML = Highlight(V_Desc, arySearchKeywords) & vbcrlf
						strTableCellClass = " descriptioncell"
					else
						strTableCellClass = ""
					end if

					%><tr<%= strRowHTML %>>
						<td class="name<% =strTableCellClass %>"><strong><% =objRecordSetVersions("V_Name" & CInt(numLanguageID)) %></strong><span><% =objRecordSetVersions("V_CodeNumber") %></span></td>
						<%
						if strAppShowWeight = "y" then 
						%><td class="weight<% =strTableCellClass %>"><%= objRecordSetVersions("V_Weight") & " " & GetAppVar("weightunit") %></td>
						<%end if
						
						if strAppShowRRP = "y" then 
							V_RRP = NumSafe(objRecordSetVersions("V_RRP")) 
							%><td class="rrp<% =strTableCellClass %>"><%= IIf(V_RRP = 0, "", objCurrency.Display(V_RRP, true, false)) %></td>
						<% end if
						
						if strAppShowStock = "y" then 
							%><td class="stock<% =strTableCellClass %>"><%
								numWarn = objRecordSetVersions("V_QuantityWarnLevel")
								If numWarn = 0 then
									response.Write "-"
								Else
									numStock = objRecordSetVersions("V_Quantity")
									If numStock < 0 then numStock = 0
									response.Write numStock
								End If
							%></td>
						<% end if
				
						'Price display
						If strAppPricesIncTax = "y" then
							If strAppShowTaxDisplay = "y" then %>
								<td class="price_1<% =strTableCellClass %>"><% =objCurrency.Display(numPriceExTax, true, false) %><%= strGroupDiscount %></td>
								<td class="price_2<% =strTableCellClass %>"><% =objCurrency.Display(numPrice, true, false) %><%= strGroupDiscount %></td><%
							Else %>
								<td class="price<% =strTableCellClass %>" colspan="2"><% =objCurrency.Display(numPrice, true, false) %><%= strGroupDiscount %></td><%
							End if
						Else
							If strAppShowTaxDisplay = "y" then %>
								<td class="price_1<% =strTableCellClass %>"><% =objCurrency.Display(numPrice, true, false) %><%= strGroupDiscount %></td>
								<td class="price_2<% =strTableCellClass %>"><% =numTax * 100 %>%</td><%
							Else %> 
								<td class="price<% =strTableCellClass %>" colspan="2"><% =objCurrency.Display(numPrice, true, false) %><%= strGroupDiscount %></td><%
							End if
						End if
						%>
						<td class="addtobasket<% =strTableCellClass %>">
							<% If objRecordSetVersions("V_Quantity") <= 0 AND objRecordSetVersions("V_QuantityWarnLevel") <> 0 and strAppAllowPurchaseOutOfStock = "n" then 
								%><img src="<% =strTemplateImagesFolder %>outofstock.gif" alt="" /><%
							
							else
								'Display add to basket
								If strAppAddToBasket <> "link" then %>
									<form method="get" action="<%= strTemplateShopFolder %>basket.asp"><div>
										<%= objCactuSession.Form %>
										<%= objTrail.Form %>
										<%= strReturnHiddenFields %>
										<input type="hidden" name="strAction" value="add" />
										<input type="hidden" name="numLineCount" value="1" />
										<input type="hidden" name="V1" value="<% =objRecordSetVersions("V_ID") %>" /><% 
										Select Case strAppAddToBasket
											Case "dropdown"	'Quantity dropdown %>
												<select name="Q1"><%
													for numCounter = 1 to GetAppVar("addtobasketdropdownmax") %>
													<option value="<% =numCounter %>"><% =numCounter %></option><% 
													next %>
												</select><% 
												
											Case "button"	'Fixed quantity %>
												<input type="hidden" name="Q1" value="1" /><%
											
											Case "textbox"	'Textbox quantity %>
												<input class="small" size="3" type="text" name="Q1" /><%
										
										End Select %>
										<input class="submit" type="submit" value="<% WriteSafeString("FormButton_Add") %>" name="strAddButton<% =numVersionRowCount %>" />
									</div></form>
								
								<% Else	'Link %>
									<span class="small"><a href="<%= strTemplateShopFolder %>basket.asp?<%= objCactuSession.QS %><%= objTrail.QS %>numLineCount=1&amp;V1=<% =objRecordSetVersions("V_ID") %>&amp;Q1=1&amp;strAction=add&amp;<% =strReturnQueryString %>"><% WriteSafeString("ContentText_AddToBasket") %></a></span><%
								End If
							End if %>
						</td>
					</tr>
					
					<% 
					'Find large image
					strLargeImageLinkHTML = ""
					strFileName = GetFileLocation(strVersionLargePath, objRecordSetVersions("V_ID"), aryFileTypes, objVersionFileSystem)
					If strFileName <> "" Then
						If gfxSpex(strVersionLargePath & "\" & strFileName, imgW, imgH, c, strType) = True Then
							strImage = strFileName
							strImageType = "version"
							strLargeImageLink = "<a href=""javascript:PopUp('" & strTemplateShopFolder & "popuplargeimage.asp?" & objCactuSession.QS & "strImage=" & strImage & "&amp;strImageType=" & strImageType & "&amp;strPageTitle=" & JavascriptPopupEncode(objRecordSetVersions("V_Name" & CInt(numLanguageID)),1) & "','_blank','scrollbars=no,width=" & imgW+20 & ",height=" & imgH+30 & "')"">"
							strLargeImageLinkHTML = "<div class=""extrainfolinks"">" & strLargeImageLink & GetString("ContentText_LargeView") & "<img class=""largeview"" src=""" & strTemplateImagesFolder & "largeview.gif"" alt=""" & WriteSafe(GetString("ContentText_LargeView")) & """ title=""" & WriteSafe(GetString("ContentText_LargeView")) & """ /></a></div>" & vbcrlf
						End if
					End if
										
					'Find regular image
					strThumbnailImageHTML = ""
					strFileName = GetFileLocation(strVersionPath, objRecordSetVersions("V_ID"), aryFileTypes, objVersionFileSystem)
					If strFileName <> "" Then
						If strLargeImageLink <> "" then
							strThumbnailImageHTML = strLargeImageLink & "<img class=""thumb"" src=""" & strTemplateShopFolder & strAppUploadsFolder & "images_versions/" & strFileName & """ alt=""" & WriteSafe(objRecordSetVersions("V_Name" & CInt(numLanguageID))) & """ /></a>" & vbcrlf
						else
							strThumbnailImageHTML = "<img src=""" & strTemplateShopFolder & strAppUploadsFolder & "images_versions/" & strFileName & """ alt=""" & WriteSafe(objRecordSetVersions("V_Name" & CInt(numLanguageID))) & """ />" & vbcrlf
						end if					
					End if
					
					'Row with description and image and large image link.
					If strThumbnailImageHTML <> "" or strDescriptionHTML <> "" or strLargeImageLinkHTML <> "" then %>
						<tr<%= strRowHTML %>>
							<td class="description" colspan="<%= numVersionColumns %>"><%
								'Write them all out						
								response.Write strThumbnailImageHTML
								response.write strDescriptionHTML
								response.write strLargeImageLinkHTML %>
							</td>
						</tr>
					<% end if
					objRecordSetVersions.moveNext
				loop 
				response.Write "</tbody>" & vbcrlf 
			response.write "</table></div>" & vbcrlf
		end if 
		
		response.Write "</div>" & vbcrlf
		
		
	end if 
	
	If SOFTWARE_IS_PRO Then
		If blnGotOneGroupDiscount then
			strLinkURL = "javascript:PopUp('" & strTemplateShopFolder & "popupquantitydiscounts.asp?" & objCactuSession.QS & "P_ID=" & numProductID & "','_blank','width=620,height=400,scrollbars=yes')"
			response.Write "<div class=""quantitydiscount"">" & GetString("ContentText_QuantityDiscountMsg1") & "<div class=""link""><a href=""" & strLinkURL & """>" & GetString("ContentText_QuantityDiscountMsg2") & " &#187;</a></div></div>"
		end if	
	end if
end sub 


'-----------------------------------------------
' SHOW PRICE LINE FUNCTION
' Displays the prices in a div. Used for option
' groups and option dropdown displays. Replies 
' on various config settings pulled out there.
'-----------------------------------------------
Function ShowPriceLine(numPrice, numTax, numRRP, blnStar, strAppPricesIncTax, strAppShowTaxDisplay, strAppShowRRP, numWeight)
	strStar = IIf(blnStar, "*", "")
	
	response.write "<div class=""prices"">"
	
	'Show Weight
	If GetAppVar("showweightonversiondisplay") = "y" and numWeight > 0 then
			response.Write "<span class=""weight"">" & GetString("ContentText_Weight") & " " & NumSafe(numWeight) & " " & GetAppVar("weightunit") & "</span>"
	end if
	
	'Show RRP
	If strAppShowRRP = "y" then
		If numRRP > 0 then 
			response.Write "<span class=""rrp"">" & GetString("ContentText_RRP") & " " & objCurrency.Display(numRRP, true, false) & "</span>"
		end if
	end if
	
	'Show price. Display type dependant on tax settings
	numPriceExTax = Round(numPrice * (1 / (1 + numTax)), 2)	

	'get price (without symbol), symbol and ISOformat
	strCurrencySymbol = Trim(replace(objCurrency.Display(numPrice, true, false), objCurrency.DisplayWithoutSymbol(numPrice, true), ""))
	numPriceForDisplay = objCurrency.DisplayWithoutSymbol(numPrice, true)
	strCurrencyFormat = objCurrency.Format
	strValueBoxAlign = IIf(right(strCurrencyFormat, 8)="[symbol]", " style=""text-align:right;""", "")

	Response.write "<input type=""hidden"" name=""origPrice" & numJscriptID & """ value=""" & objCurrency.DisplayWithoutSymbol(numPrice, true) & """ id=""origPrice" & numJscriptID & """ />" & vbcrlf
	Response.write "<input type=""hidden"" name=""numTax" & numJscriptID & """ value=""" & (1/(1+numTax)) & """ id=""numTax" & numJscriptID & """ />" & vbcrlf
	Response.write "<input type=""hidden"" name=""numFixedPlaces" & numJscriptID & """ value=""" & IIf(objCurrency.HasDecimals, 2, 0) & """ id=""numFixedPlaces" & numJscriptID & """ />" & vbcrlf

	If strAppPricesIncTax = "y" then
		If strAppShowTaxDisplay = "y" then
			Response.write "<span class=""extax"">" & GetString("ContentText_ExTax") & " " & replace(replace(strCurrencyFormat, "[value]", "<input" & strValueBoxAlign & " type=""text"" class=""extax"" name=""txtPriceEx" & numJscriptID & """ value=""" & numPriceForDisplay & """ id=""txtPriceEx" & numJscriptID & """ readonly=""readonly""/>"), "[symbol]", strCurrencySymbol) & "</span>"& vbcrlf
			
			Response.write "<span class=""inctax"">" & GetString("ContentText_IncTax") & strStar & " " & replace(replace(strCurrencyFormat, "[value]", "<input" & strValueBoxAlign & " type=""text"" class=""inctax"" name=""txtPrice" & numJscriptID & """ value=""" & numPriceForDisplay & """ id=""txtPrice" & numJscriptID & """ readonly=""readonly""/>"), "[symbol]", strCurrencySymbol) & "</span>"
		Else
			Response.write "<span class=""inctax"">" & GetString("ContentText_IncTax") & strStar & " " & replace(replace(strCurrencyFormat, "[value]", " <input" & strValueBoxAlign & " type=""text"" class=""inctax"" name=""txtPrice" & numJscriptID & """ value=""" & numPriceForDisplay & """ id=""txtPrice" & numJscriptID & """ readonly=""readonly""/>"), "[symbol]", strCurrencySymbol) & "</span>"
		End if
	Else
		If strAppShowTaxDisplay = "y" then
			Response.write "<span class=""inctax"">" & GetString("ContentText_Price") & strStar & " " & replace(replace(strCurrencyFormat, "[value]", "<input" & strValueBoxAlign & " type=""text"" class=""inctax"" name=""txtPrice" & numJscriptID & """ value=""" & numPriceForDisplay & """ id=""txtPrice" & numJscriptID & """ readonly=""readonly""/>"), "[symbol]", strCurrencySymbol) & "</span> " & " <span class=""extax"">(+ " & (numTax * 100) & "% " & GetString("ContentText_Tax") & ")</span>"
		Else
			Response.write "<span class=""inctax"">" & GetString("ContentText_Price") & strStar & " " & replace(replace(strCurrencyFormat, "[value]", "<input" & strValueBoxAlign & " type=""text"" class=""inctax"" name=""txtPrice" & numJscriptID & """ value=""" & numPriceForDisplay & """ id=""txtPrice" & numJscriptID & """ readonly=""readonly""/>"), "[symbol]", strCurrencySymbol) & "</span>"
		End if
	End if
	response.write "</div>" & vbcrlf
End Function
%>
